#include<bits/stdc++.h>
#define maxNM 12
using namespace std;

int n, m;
bool ispisao = false;
void ispisi(char mat[][maxNM]) {
    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= m; ++j) {
            if(mat[i][j] == '-')
                cout << '.';
            else
                cout << mat[i][j];
        }
        cout << endl;
    }
    ispisao = true;
    return;
}
int popuniCrtice(char mat[][maxNM], int i, int j) {
    int pi = i, pj = j;
    int napadnutaPolja = 0;
    for(j = j - 1; j > 0; --j) {
        if(mat[i][j] == '.' || mat[i][j] == 'X') {
            mat[i][j] = '-';
            ++napadnutaPolja;
        }
        else if(mat[i][j] == '-')
            continue;
        else break;
    }
    j = pj;

    for(i = i - 1; i > 0; --i) {
        if(mat[i][j] == '.' || mat[i][j] == 'X') {
            mat[i][j] = '-';
            ++napadnutaPolja;
        }
        else if(mat[i][j] == '-')
            continue;
        else break;
    }
    i = pi;

    for(j = j + 1; j <= m; ++j) {
        if(mat[i][j] == '.' || mat[i][j] == 'X') {
            mat[i][j] = '-';
            ++napadnutaPolja;
        }
        else if(mat[i][j] == '-')
            continue;
        else break;
    }
    j = pj;
    for(i = i + 1; i <= n; ++i) {
        if(mat[i][j] == '.' || mat[i][j] == 'X') {
            mat[i][j] = '-';
            ++napadnutaPolja;
        }
        else if(mat[i][j] == '-')
            continue;
        else break;
    }
    i = pi;

    return napadnutaPolja; // popunili smo napadnuta polja
}
void solve(char mat[][maxNM], int i, int j, int nedostajePolja, int nedostajeBrojeva) {
    if(nedostajePolja == 0 && nedostajeBrojeva == 0) {
        ispisi(mat);
        return; // nasli smo kombinaciju koja radi - kraj
    }
    if(i == n + 1) {
        return;
    }
    int ppppp = j;
    bool asd = false;
    for(; i <= n; ++i) {
        for(j = (asd) ? 1 : ppppp; j <= m; ++j) {
            if(mat[i][j] == '.' && mat[i][j - 1] != '0' && mat[i - 1][j] != '0' && mat[i][j + 1] != '0' && mat[i + 1][j] != '0') {
                mat[i][j] = 'C';
                --nedostajePolja;
                nedostajePolja -= popuniCrtice(mat, i, j);
                if(isdigit(mat[i][j - 1])) {
                    --mat[i][j - 1];
                    --nedostajeBrojeva;
                }
                if(isdigit(mat[i - 1][j])) {
                    --mat[i - 1][j];
                    --nedostajeBrojeva;
                }
                if(isdigit(mat[i][j + 1])) {
                    --mat[i][j + 1];
                    --nedostajeBrojeva;
                }
                if(isdigit(mat[i + 1][j])) {
                    --mat[i + 1][j];
                    --nedostajeBrojeva;
                }

                if(j == m) {
                    solve(mat, i + 1, 1, nedostajePolja, nedostajeBrojeva); // prebaci u novi red
                }
                else solve(mat, i, j + 1, nedostajePolja, nedostajeBrojeva); // idi na sledece polje

            }
            asd = true;
        }
    }

    return;

}
int main() {
    char mat[maxNM][maxNM];
    cin >> n >> m;
    int nedostajePolja = 0;
    int nedostajeBrojeva = 0;

    for(int i = 0; i <= m + 1; ++i) {
        mat[0][i] = '?';
        mat[n + 1][i] = '?';
    }
    for(int i = 0; i <= n + 1; ++i) {
        mat[i][0] = '?';
        mat[i][m + 1] = '?';
    }


    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= m; ++j) {
            cin >> mat[i][j];
            if(mat[i][j] == '.') {
                ++nedostajePolja;
            }
            if(isdigit(mat[i][j])) {
                nedostajeBrojeva += mat[i][j] - '0';
            }
        }
    }
    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= m; ++j) {
            if(mat[i][j] == '0') {
                if(mat[i][j - 1] == '.') {
                    mat[i][j - 1] = 'X';
                }
                if(mat[i - 1][j] == '.') {
                    mat[i - 1][j] = 'X';
                }
                if(mat[i][j + 1] == '.') {
                    mat[i][j + 1] = 'X';
                }
                if(mat[i + 1][j] == '.') {
                    mat[i + 1][j] = 'X';
                }
            }
        }
    }

    /*for(int i = 0; i <= n + 1; ++i) {
        for(int j = 0; j <= m + 1; ++j)
            cout << mat[i][j] << ' ';
        cout << endl;
    }*/
    solve(mat, 1, 1, nedostajePolja, nedostajeBrojeva);
    if(!ispisao)
        cout << -1;

    return 0;
}